hdu 2828 Lamp(重复覆盖)

来源:互联网 发布:数据库隔离级别和事务 编辑:程序博客网 时间:2024/05/22 03:13

Lamp

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 846    Accepted Submission(s): 260
Special Judge


Problem Description
There are several switches and lamps in the room, however, the connections between them are very complicated. One lamp may be controlled by several switches, and one switch may controls at most two lamps. And what’s more, some connections are reversed by mistake, so it’s possible that some lamp is lighted when its corresponding switch is “OFF”!

To make things easier, we number all the lamps from 1 to N, and all the switches 1 to M. For each lamps, we give a list of switches controlling it. For example, for Lamp 1, the list is “1 ON 3 OFF 9 ON”, that means Lamp 1 will be lighted if the Switch 1 is at the “ON” state OR the Switch 3 is “OFF” OR the Switch 9 is “ON”.

Now you are requested to turn on or off the switches to make all the lamps lighted.
 

Input
There are several test cases in the input. The first line of each test case contains N and M (1 <= N,M <= 500), then N lines follow, each indicating one lamp. Each line begins with a number K, indicating the number of switches controlling this lamp, then K pairs of “x ON” or “x OFF” follow.
 

Output
Output one line for each test case, each contains M strings “ON” or “OFF”, indicating the corresponding state of the switches. For the solution may be not unique, any correct answer will be OK. If there are no solutions, output “-1” instead.
 

Sample Input
2 22 1 ON 2 ON1 1 OFF2 11 1 ON1 1 OFF
 

Sample Output
OFF ON-1
题意:有n盏灯,m个开关,每个开关有开和关两种状态。给出每盏灯亮时需要哪种开关的哪个状态,问是否能安排出所有开关的状态,使得没盏灯都亮,输出方案。
思路:好容易看出是覆盖问题,每盏灯看成列,每个开关的两种状态各位一行,一共有M*2行,N列。因为同一列可以被多个行覆盖,所以不能用精确覆盖,要用重复覆盖。
AC代码:
#include <cstdio>#include <cstring>#include <iostream>#include <cmath>#include <algorithm>#include <vector>#include <bitset>#include <queue>#define ll long longusing namespace std;const int maxn = 1000005;const int INF = 1e9;struct DLX{    #define FF(i,A,s) for(int i = A[s];i != s;i = A[i])    int L[maxn],R[maxn],U[maxn],D[maxn];    int size,col[maxn],row[maxn],s[maxn],H[maxn];    bool vis[1200];    int ans[maxn],cnt;    void init(int m){        for(int i=0;i<=m;i++){            L[i]=i-1;R[i]=i+1;U[i]=D[i]=i;s[i]=0;        }        memset(H,-1,sizeof(H));        L[0]=m;R[m]=0;size=m+1;        memset(vis,0,sizeof(vis));    }    void link(int r,int c){         U[size]=c;D[size]=D[c];U[D[c]]=size;D[c]=size;         if(H[r]<0)H[r]=L[size]=R[size]=size;         else {             L[size]=H[r];R[size]=R[H[r]];             L[R[H[r]]]=size;R[H[r]]=size;         }         s[c]++;col[size]=c;row[size]=r;size++;     }    void del(int c){//精确覆盖        L[R[c]]=L[c];R[L[c]]=R[c];        FF(i,D,c)FF(j,R,i)U[D[j]]=U[j],D[U[j]]=D[j],--s[col[j]];    }    void add(int c){  //精确覆盖        R[L[c]]=L[R[c]]=c;        FF(i,U,c)FF(j,L,i)++s[col[U[D[j]]=D[U[j]]=j]];    }    bool dfs(int k){//精确覆盖        if(!R[0]){            cnt=k;return 1;        }        int c=R[0];FF(i,R,0)if(s[c]>s[i])c=i;        del(c);        FF(i,D,c){            FF(j,R,i)del(col[j]);            ans[k]=row[i];if(dfs(k+1))return true;            FF(j,L,i)add(col[j]);        }        add(c);        return 0;    }    void remove(int c){//重复覆盖        FF(i,D,c)L[R[i]]=L[i],R[L[i]]=R[i];    }     void resume(int c){//重复覆盖         FF(i,U,c)L[R[i]]=R[L[i]]=i;     }    int A(){//估价函数        int res=0;        memset(vis,0,sizeof(vis));        FF(i,R,0)if(!vis[i]){                res++;vis[i]=1;                FF(j,D,i)FF(k,R,j)vis[col[k]]=1;            }        return res;    }    bool dance(int now){//重复覆盖        if(R[0]==0)return 1;            int temp=INF,c;            FF(i,R,0)if(temp>s[i])temp=s[i],c=i;            FF(i,D,c){                if(vis[row[i]^1])continue;                vis[row[i]]=1;remove(i);                FF(j,R,i)remove(j);                if(dance(now+1))return 1;                FF(j,L,i)resume(j);                resume(i);vis[row[i]]=0;            }            return 0;    }}dlx;int main(){    int n, m;    while(~scanf("%d%d", &n, &m)){        dlx.init(n);        for(int i = 1; i <= n; i++){            int a, b;            char str[5];            scanf("%d",&a);            while(a--){                scanf("%d%s", &b, str);                if(str[1] == 'N') dlx.link((b - 1) << 1,i);                else dlx.link((b - 1) << 1 | 1,i);            }        }        if(!dlx.dance(0)) puts("-1");        else{            if(!dlx.vis[1]) printf("ON");            else printf("OFF");            for(int i = 2; i < (m << 1); i += 2){                if(!dlx.vis[i]) printf(" OFF");                else printf(" ON");            }            puts("");        }    }    return 0;}


0 0
原创粉丝点击